# Technical documentation
## Frontend
1. [HTML 5](https://developer.mozilla.org/en-US/docs/Glossary/HTML5)
1. [CSS 3](https://developer.mozilla.org/pl/docs/Web/CSS)
1. [JavaScript](https://developer.mozilla.org/pl/docs/orphaned/Web/JavaScript)
1. [TypeScript](https://www.typescriptlang.org/docs/ "Documentation")
1. [Angular 12](https://angular.io/docs "Documentation") (Frontend framework)
## Backend
1. [PHP 8.0](https://www.php.net/docs.php "Documentation")
1. [Symfony 5](https://symfony.com/doc/current/index.html "Documentation") (PHP Framework)
1. [Postgresql 13](https://www.postgresql.org/docs/13/index.html "Documentation") (Database)
1. [Docker](https://docs.docker.com/) (Local development environment)

## Tools
### Neccessary
1. [Docker](https://docs.docker.com/) - to run local environment
### Optional
1. [Firefox Developer Edition](https://www.mozilla.org/pl/firefox/developer/)
2. [VS Code](https://code.visualstudio.com/) - [IDE](https://en.wikipedia.org/wiki/Integrated_development_environment)
    - Plugins for PHP
        - [PHP Debug](https://marketplace.visualstudio.com/items?itemName=felixfbecker.php-debug)
        - [PHP Intelephense](https://marketplace.visualstudio.com/items?itemName=bmewburn.vscode-intelephense-client)
    - Plugins for Angular
        - [Angular Language Service](https://marketplace.visualstudio.com/items?itemName=Angular.ng-template)
    - Plugins for database
        - [SQLTools](https://marketplace.visualstudio.com/items?itemName=mtxr.sqltools)
        - [SQLTools PostgreSQL/Redshift Driver](https://marketplace.visualstudio.com/items?itemName=mtxr.sqltools-driver-pg)
    - Plugins for git:
        1. [GitLens](https://marketplace.visualstudio.com/items?itemName=eamodio.gitlens)

## How to run app?
1. Download project from repository using standalone git or built in any IDE
2. Install Docker Desktop
3. run command line and go to project directory
4. Go to docker directory
5. Execute `docker compose -p curenet up`
6. Wait until docker building and lauching the app.
    At first attempt it can take a few minutes

## Application links
1. Main app: `http://localhost:7700`
2. PgAdmin4 `http://localhost:7700/pgadmin4`
3. PHP Xdebug for fpm: `localhost:7780`
3. PHP Xdebug for cli: `localhost:7781`

## Credentials
### PgAdmin4
- Login: `admin@pgadmin.localhost`
- Password: `WeryStronkPaz2`
- Configuration:
    1. Click on Server in left panel
    2. Go to Create > Server
    3. Enter name (you can name it as you want)
    4. Go to Connection tab
    5. Enter host name: `localhost`
    6. Enter username: `postgres`
    7. Enter password: `WeryStronkPaz2`
    8. Save it
    9. Go to Servers > [your name] > Databases > curenet > Schemas > public > Tables
    10. You can see all tables
### Database
- Server: `localhost`
- Port: `5432`
- Username
    - For application: `curenet`
    - For admin: `postgres`
- Database
    - For application: `curenet`
    - For admin: `postgres`
- Password: `WeryStronkPaz2`
